import sys
import time
import random

start = time.time()

k = int(sys.argv[2])
m = int(open(sys.argv[1]+'.m').readline())
n = int(open(sys.argv[1]+'.n').readline())

gamma = 1.5
rho = 1.1
alpha = m * (k ** (gamma - 1)) / ((2*m) ** gamma)


partitions = []
cost = []
for i in range(k):
    partitions.append([])
    cost.append(0)
partlist = range(k)

azklra = 0
for l in open(sys.argv[1]+'.neighbours'):
    if l[0] != '#':
        s = l.split('\t')
        nb = [int(x)-1 for x in s]
        maxi = (None,partlist)
        for j in range(k):
            s = len(set(nb)&set(partitions[j]))
            s += alpha * cost[j]**gamma - alpha * (cost[j] + len(nb))**gamma
            if len(partitions[j]) < (n * rho / k):
                if s > maxi[0]:
                    maxi = (s,[j])
                elif s == maxi[0]:
                    maxi[1].append(j)
        part = maxi[1][int(random.random()*len(maxi[1]))]
        print >> open(sys.argv[1]+'.vertex.'+str(k),'a+'), part
        partitions[part].append(azklra)
        cost[part] += len(nb)
        azklra += 1
        print azklra

runtime = time.time() - start

print >> open(sys.argv[1]+'.vertex.'+str(k)+'.runtime','a+'), runtime
